#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <stdlib.h>
#include <locale>
#include <exception>
#include <sstream>
#include <unordered_map>
#include <locale>

using namespace std;

using u_kompartor = bool(*)(wstring, wstring);
//typedef bool(*u_kompartor)(wstring, wstring);

wchar_t * text_npovdy = LR"(Filtr SORT
Pouit: SORT [volba] < vstupn_soubor  > vstupn_soubor

volba            vznam
-----------------------
-n nebo /n       azen podle sel
-l nebo /l       lexikografick azen
-a nebo /a       abecedn azen
)";

locale lokl("Czech");

bool podle_sel(wstring dka1, wstring dka2);
bool lexikograficky(wstring dka1, wstring dka2);
bool abecedn(wstring dka1, wstring dka2);

unordered_map<string, u_kompartor> tabulka_voleb = { { "-n", podle_sel },
{ "/n", podle_sel },
{ "-l", lexikograficky },
{ "/l", lexikograficky },
{ "-a", abecedn },
{ "/a", abecedn },
};

void npovda()
{
	wcerr.imbue(locale("Czech_Czech Republic.852"));
	wcerr << text_npovdy << endl;
	exit(0);
}

void azen(u_kompartor komp)
{
	wstring dka;
	vector<wstring> vstup;

	wcout.imbue(lokl);
	wcin.imbue(lokl);

	while (getline(wcin, dka))
	{
		vstup.push_back(dka);
	}
	sort(vstup.begin(), vstup.end(), komp);
	for (wstring lajna : vstup)
	{
		wcout << lajna << endl;
	}
}

bool abecedn(wstring dka1, wstring dka2)
{
	return lokl(dka1, dka2);
}

bool podle_sel(wstring dka1, wstring dka2)
{
	wistringstream A(dka1), B(dka2);
	int nPrvni = 0, nDruhy = 0;
	A >> nPrvni;
	B >> nDruhy;
	return nPrvni <= nDruhy;
}

bool lexikograficky(wstring dka1, wstring dka2)
{
	return dka1 <= dka2;
}


int main(int argc, char** argv)
{
	try
	{
		if (argc != 2) throw out_of_range("");
		azen(tabulka_voleb.at(argv[1]));
	}
	catch (out_of_range)
	{
		npovda();
	}
}