#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <stdlib.h>
#include <locale>
#include <exception>
#include <sstream>
#include <unordered_map>
#include <locale>
#include <windows.h>

using namespace std;

using u_kompartor = bool(*)(wstring, wstring);
//typedef bool(*u_kompartor)(wstring, wstring);

wchar_t * text_npovdy = LR"(
Filtr SORT
Pouit: SORT volba < vstupn_soubor  > vstupn_soubor

volba            vznam
-----------------------
-n nebo /n       azen podle sel
-l nebo /l       lexikografick azen
-a nebo /a       abecedn azen
)";


enum class typ{ dos, win };

string info_o_loklu(LCID lcid, int co)
{
	char text[128] = { 0 };
	GetLocaleInfoA(lcid, co, text, 127);
	return string(text);
}

string popis_loklu(typ kter)
{
	LCID lcid = GetUserDefaultLCID();
	string popis = info_o_loklu(lcid, LOCALE_SENGLANGUAGE);
	if (popis.length() == 0)
	{
		return "C";
	}
	string pom = info_o_loklu(lcid, LOCALE_SENGCOUNTRY);
	if (pom.length() > 0)
	{
		popis += "_" + pom;
	}
	else
	{
		return popis;
	}
	int co = (kter == typ::win) ? LOCALE_IDEFAULTANSICODEPAGE : LOCALE_IDEFAULTCODEPAGE;
	pom = info_o_loklu(lcid, co);
	if (pom.length() > 0)
	{
		popis += "." + pom;
	}
	return popis;
}

locale lokl(popis_loklu(typ::win));

bool podle_sel(wstring dka1, wstring dka2);


unordered_map<string, u_kompartor> tabulka_voleb = { { "-n", podle_sel },
{ "-l", [](wstring 1, wstring 2)->bool {return 1 <= 2; } },
{ "-a", [](wstring 1, wstring 2)->bool {return lokl(1, 2); } },
};

void npovda()
{
	wcerr.imbue(locale(popis_loklu(typ::dos)));
	wcerr << text_npovdy << endl;
	exit(0);
}

void azen(u_kompartor komp)
{
	wstring dka;
	vector<wstring> vstup;

	wcout.imbue(lokl);
	wcin.imbue(lokl);

	while (getline(wcin, dka))
	{
		vstup.push_back(dka);
	}
	sort(vstup.begin(), vstup.end(), komp);
	for (wstring lajna : vstup)
	{
		wcout << lajna << endl;
	}
}

bool podle_sel(wstring dka1, wstring dka2)
{
	wistringstream A(dka1), B(dka2);
	int nPrvni = 0, nDruhy = 0;
	A >> nPrvni;
	B >> nDruhy;
	return nPrvni <= nDruhy;
}


int main(int argc, char** argv)
{
	try
	{
		if (argc != 2) throw out_of_range("");
		if (argv[1][0] == '/')argv[1][0] = '-';
		azen(tabulka_voleb.at(argv[1]));
	}
	catch (out_of_range)
	{
		npovda();
	}
}