#include <iostream>
#include <memory>
#include <thread>
#include <chrono>
#include <mutex>
#include <stdlib.h>


using namespace std;

struct Nstroj 
{
	Nstroj() { cout << "  Nstroj::Nstroj()\n"; }
	~Nstroj() { cout << "  Nstroj::~Nstroj()\n"; }
};

void podproces(shared_ptr<Nstroj> p)
{
	this_thread::sleep_for(/*chrono::seconds(1)*/1s);
	shared_ptr<Nstroj> lp = p; // Bezpen ve vcevlknovm prosted, i kdy 
							   // se mn use_count 
	{
		static mutex io_mutex;
		lock_guard<mutex> zmek(io_mutex);
		cout << "Lokln ukazatel v podprocesu:\n"
			 << "  lp.get() = " << lp.get()
			 << ", lp.use_count() = " << lp.use_count() << '\n';
	}
}

int main()
{
	system("CHCP 1250 > NULL");
	shared_ptr<Nstroj> p = make_shared<Nstroj>();

	cout << "Vytvoen sdlen Nstroj\n"
		 << "  p.get() = " << p.get()
		 << ", p.use_count() = " << p.use_count() << '\n';
	thread t1(podproces, p), t2(podproces, p), t3(podproces, p);
	p.reset(); // Uvoln vlastnictv z main()
	cout << "Sdlen vlastnictv mezi 3 podprocesy a uvolnn\n"
		 << "vlastnictv z main():\n"
		 << "  p.get() = " << p.get()
		 << ", p.use_count() = " << p.use_count() << '\n';
	t1.join(); t2.join(); t3.join();
	cout << "Podprocesy skonily, posledn uvolnil Nstroj.\n";
}
